Exiv2: Exiv2::JpegBase Class Reference

# Exiv2::JpegBase Class Reference

Abstract helper base class to access JPEG images. More...

`#include <jpgimage.hpp>`

Inheritance diagram for Exiv2::JpegBase:
[legend]
Collaboration diagram for Exiv2::JpegBase:
[legend]

List of all members.

## Public Member Functions
Manipulators
void | readMetadata ()
| Read all metadata supported by a specific image format from the image. Before this method is called, the image metadata will be cleared.
void | writeMetadata ()
| Write metadata back to the image.
## Protected Member Functions
Creators
| JpegBase (int type, BasicIo::AutoPtr io, bool create, const byte initData[], long dataSize)
| Constructor that can either open an existing image or create a new image from scratch. If a new image is to be created, any existing data is overwritten.
Accessors
virtual bool | isThisType (BasicIo &iIo, bool advance) const =0
| Determine if the content of the BasicIo instance is of the type supported by this class.
Manipulators
virtual int | writeHeader (BasicIo &oIo) const =0
| Writes the image header (aka signature) to the BasicIo instance.
## Static Protected Attributes
static const byte | sos_
| JPEG SOS marker.
static const byte | eoi_
| JPEG EOI marker.
static const byte | app0_
| JPEG APP0 marker.
static const byte | app1_
| JPEG APP1 marker.
static const byte | app13_
| JPEG APP13 marker.
static const byte | com_
| JPEG Comment marker.
static const char | exifId_ []
| Exif identifier.
static const char | jfifId_ []
| JFIF identifier.
static const char | xmpId_ []
| XMP packet identifier.

## Detailed Description

Abstract helper base class to access JPEG images.

## Constructor & Destructor Documentation

Exiv2::JpegBase::JpegBase | ( | int | type,
|  | BasicIo::AutoPtr | io,
|  | bool | create,
|  | const byte | initData[],
|  | long | dataSize |
| ) |  |  | `[protected]`

Constructor that can either open an existing image or create a new image from scratch. If a new image is to be created, any existing data is overwritten.

Parameters:

  | type | Image type.
  | io | An auto-pointer that owns a BasicIo instance used for reading and writing image metadata. Important: The constructor takes ownership of the passed in BasicIo instance through the auto-pointer. Callers should not continue to use the BasicIo instance after it is passed to this method. Use the Image::io() method to get a temporary reference.
  | create | Specifies if an existing image should be read (false) or if a new image should be created (true).
  | initData | Data to initialize newly created images. Only used when create is true. Should contain data for the smallest valid image of the calling subclass.
  | dataSize | Size of initData in bytes.

## Member Function Documentation

void Exiv2::JpegBase::readMetadata | ( |  | ) | `[virtual]`

Read all metadata supported by a specific image format from the image. Before this method is called, the image metadata will be cleared.

This method returns success even if no metadata is found in the image. Callers must therefore check the size of individual metadata types before accessing the data.

Exceptions:

  | Error | if opening or reading of the file fails or the image data is not valid (does not look like data of the specific image type).

Implements Exiv2::Image.

void Exiv2::JpegBase::writeMetadata | ( |  | ) | `[virtual]`

Write metadata back to the image.

All existing metadata sections in the image are either created, replaced, or erased. If values for a given metadata type have been assigned, a section for that metadata type will either be created or replaced. If no values have been assigned to a given metadata type, any exists section for that metadata type will be removed from the image.

Exceptions:

  | Error | if the operation fails

Implements Exiv2::Image.

virtual bool Exiv2::JpegBase::isThisType | ( | BasicIo & | iIo,
|  | bool | advance |
| ) |  |  | const`[protected, pure virtual]`

Determine if the content of the BasicIo instance is of the type supported by this class.

The advance flag determines if the read position in the stream is moved (see below). This applies only if the type matches and the function returns true. If the type does not match, the stream position is not changed. However, if reading from the stream fails, the stream position is undefined. Consult the stream state to obtain more information in this case.

Parameters:

  | iIo | BasicIo instance to read from.
  | advance | Flag indicating whether the position of the io should be advanced by the number of characters read to analyse the data (true) or left at its original position (false). This applies only if the type matches.

Returns:
  true if the data matches the type of this class;
  false if the data does not match

Implemented in Exiv2::JpegImage, and Exiv2::ExvImage.

virtual int Exiv2::JpegBase::writeHeader | ( | BasicIo & | oIo | ) | const`[protected, pure virtual]`

Writes the image header (aka signature) to the BasicIo instance.

Parameters:

  | oIo | BasicIo instance that the header is written to.

Returns:
  0 if successful;
  4 if the output file can not be written to

Implemented in Exiv2::JpegImage, and Exiv2::ExvImage.

The documentation for this class was generated from the following file:

- jpgimage.hpp